com.collabnet.ce.soap60.webservices.tracker

## Class TrackerAppSoapStub

- java.lang.Object
- - com.collabnet.ce.soap60.webservices.ClientSoapStub
  - - com.collabnet.ce.soap60.webservices.tracker.TrackerAppSoapStub

- All Implemented Interfaces:
    ITrackerAppSoap

      public class TrackerAppSoapStub
      extends com.collabnet.ce.soap60.webservices.ClientSoapStub
      implements ITrackerAppSoap

- - ### Field Summary

    - ### Fields inherited from class com.collabnet.ce.soap60.webservices.ClientSoapStub

      `DEFAULT_CLIENT_TIME_OUT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TrackerAppSoapStub(String soapServerUrl)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDateField(String sessionId, String trackerId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String helpText)` Adds a custom Date field to a tracker.
    `void` | `addMultiSelectField(String sessionId, String trackerId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String[] defaultValues, String helpText)` Adds a custom multi select field to a tracker.
    `void` | `addSeparator(String sessionId, String trackerId, String separatorType, String separatorLabel)` Adds a separator to a tracker.
    `void` | `addSingleSelectChildField(String sessionId, String trackerId, String fieldName, String[] fieldValues, String parentFieldId, com.collabnet.ce.soap60.types.SoapNamedValues parentChildFieldValueMap, String helpText)` Adds a custom single select field to a tracker.
    `void` | `addSingleSelectField(String sessionId, String trackerId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String defaultValue, String helpText)` Adds a custom single select field to a tracker.
    `void` | `addTextField(String sessionId, String trackerId, String fieldName, int displayColumns, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String defaultValue, String helpText, String pattern)` Adds a custom text field to a tracker.
    `void` | `addUserSelectField(String sessionId, String trackerId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] defaultValues, String userFilter, String helpText)` Adds a custom User selection field to a tracker.
    `Tracker2SoapDO` | `cloneTracker(String sessionId, String srcTrackerId, String destTrackerTitle, String destTrackerDescription)` Clone Tracker within the same project
    `Tracker2SoapDO` | `cloneTrackerAcrossProject(String sessionId, String srcTrackerId, String destProjectId, String destTrackerTitle, String destTrackerDescription)` Clone Tracker across the project
    `void` | `copyWorkflowTransitions(String sessionId, String srcTrackerId, String dstTrackerId)` Copies workflow transitions between two trackers.
    `ArtifactSoapDO` | `createArtifact(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, String assignedUsername, String releaseId, String planningFolderId, com.collabnet.ce.soap60.types.SoapFieldValues flexFields, String attachmentFileName, String attachmentMimeType, String attachmentFileId)` Creates a new artifact.
    `ArtifactSoapDO` | `createArtifact2(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, String assignedUsername, String releaseId, String planningFolderId, com.collabnet.ce.soap60.types.SoapFieldValues flexFields, AttachmentSoapDO[] attachments)` Creates a new artifact with multiple attachments.
    `Artifact2SoapDO` | `createArtifact3(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, boolean autoSummingPoints, String assignedUsername, String releaseId, String planningFolderId, String teamId, com.collabnet.ce.soap60.types.SoapFieldValues flexFields, AttachmentSoapDO[] attachments)` Creates a new artifact with multiple attachments and flag to enable the autosumming_points.
    `Artifact3SoapDO` | `createArtifact4(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, boolean autoSummingPoints, String assignedUsername, String releaseId, String planningFolderId, String teamId, com.collabnet.ce.soap60.types.SoapFieldValues flexFields, AttachmentSoapDO[] attachments, String[] tagNames)` Creates a new artifact with multiple attachments, flag to enable the autosumming_points and tags.
    `void` | `createArtifactDependency(String sessionId, String originId, String targetId, String desc)` Creates an artifact dependency between two artifacts.
    `TrackerSoapDO` | `createTracker(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon)` Creates a new tracker with an icon
    `Tracker2SoapDO` | `createTracker2(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon, String trackerUnitId)` Creates a new tracker with an icon
    `Tracker3SoapDO` | `createTracker3(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon, String trackerUnitId, boolean autosumForeignChildren)` Creates a new tracker with autosum foreign children support
    `void` | `deleteArtifact(String sessionId, String artifactId)` Deletes an artifact.
    `void` | `deleteField(String sessionId, String objectId, String fieldId)` Deletes a custom/flex-field .
    `void` | `deleteSeparator(String sessionId, String trackerId, String layoutId)` Deletes a separator of a tracker layout.
    `ArtifactSoapList` | `findArtifacts(String sessionId, String queryString, String projectId, boolean searchAttachments)` Finds a list of artifacts matching a search string.
    `Artifact2SoapList` | `findArtifacts2(String sessionId, String queryString, String projectId, boolean searchAttachments)` Finds a list of artifacts matching a search string.
    `WorkflowTransitionSoapList` | `getAllowedWorkflowTransitionList(String sessionId, String trackerId)` Gets workflow transitions for the tracker.
    `WorkflowTransition2SoapList` | `getAllowedWorkflowTransitionList2(String sessionId, String trackerId)` Gets workflow transitions for the tracker.
    `WorkflowTransition3SoapList` | `getAllowedWorkflowTransitionList3(String sessionId, String trackerId)` Gets workflow transitions for the tracker.
    `ArtifactSoapDO` | `getArtifactData(String sessionId, String artifactId)` Returns data associated with the specified artifact.
    `Artifact2SoapDO` | `getArtifactData2(String sessionId, String artifactId)` Returns data associated with the specified artifact.
    `Artifact3SoapDO` | `getArtifactData3(String sessionId, String artifactId)` Returns data associated with the specified artifact.
    `ArtifactDetailSoapList` | `getArtifactDetailList(String sessionId, String trackerId, String[] selectedColumns, com.collabnet.ce.soap60.types.SoapFilter[] filters, com.collabnet.ce.soap60.types.SoapSortKey[] sortKeys, int startIndex, int maxRows, boolean exceptionIfExpiredCache, boolean forceNewQuery)` Returns a filtered and ordered list of artifacts from the specified tracker.
    `ArtifactDetail2SoapList` | `getArtifactDetailList2(String sessionId, String trackerId, String[] selectedColumns, com.collabnet.ce.soap60.types.SoapFilter[] filters, com.collabnet.ce.soap60.types.SoapSortKey[] sortKeys, int startIndex, int maxRows, boolean exceptionIfExpiredCache, boolean forceNewQuery)` Returns a filtered and ordered list of artifacts from the specified tracker.
    `ArtifactSoapList` | `getArtifactList(String sessionId, String containerId, com.collabnet.ce.soap60.types.SoapFilter[] filters)` Returns a filtered list of artifacts within the specified container (project or tracker).
    `Artifact2SoapList` | `getArtifactList2(String sessionId, String containerId, com.collabnet.ce.soap60.types.SoapFilter[] filters)` Returns a filtered list of artifacts within the specified container (project or tracker).
    `ArtifactDependencySoapList` | `getChildDependencyList(String sessionId, String artifactId)` Gets the dependency list for an artifact where the artifact is the origin artifact.
    `ArtifactDetailSoapList` | `getCrossTrackerArtifactList(String sessionId, String containerId, com.collabnet.ce.soap60.types.SoapFilter[] filters, String[] selectedColumns)` Returns a filtered list of artifacts within the specified container (project or tracker).
    `ArtifactDetail2SoapList` | `getCrossTrackerArtifactList2(String sessionId, String containerId, com.collabnet.ce.soap60.types.SoapFilter[] filters, String[] selectedColumns)` Returns a filtered list of artifacts within the specified container (project or tracker).
    `TrackerFieldSoapDO[]` | `getFields(String sessionId, String trackerId)` Returns the custom/flex-fields associated with a specific tracker.
    `TrackerField2SoapDO[]` | `getFields2(String sessionId, String trackerId)` Returns the custom/flex-fields associated with a specific tracker.
    `OrderedTrackerFieldSoapList` | `getOrderedTrackerFields(String sessionId, String trackerId)` Returns all fields and separators in the given tracker with layout information.
    `ArtifactDependencySoapList` | `getParentDependencyList(String sessionId, String artifactId)` Gets the dependency list for an artifact where the artifact is the target artifact.
    `Tracker2SoapDO` | `getTracker2Data(String sessionId, String trackerId)` Returns a data object for a given tracker
    `Tracker2SoapList` | `getTracker2List(String sessionId, String projectId)` Returns a list of trackers for a project in the order that they are displayed in the UI.
    `Tracker3SoapDO` | `getTracker3Data(String sessionId, String trackerId)` Returns a data object for a given tracker
    `Tracker3SoapList` | `getTracker3List(String sessionId, String projectId)` Returns a list of trackers for a project in the order that they are displayed in the UI.
    `TrackerSoapDO` | `getTrackerData(String sessionId, String trackerId)` Returns a data object for a given tracker
    `TrackerSoapList` | `getTrackerList(String sessionId, String projectId)` Returns a list of trackers for a project in the order that they are displayed in the UI.
    `TrackerUnitSoapList` | `getUnitsByProject(String sessionId, String projectId)` Gets the units for a given project.
    `ArtifactSoapDO` | `moveArtifact(String sessionId, String artifactId, String targetFolderId, String newAssignee)` Moves an artifact to a specified target folder.
    `Artifact2SoapDO` | `moveArtifact2(String sessionId, String artifactId, String targetFolderId, String newAssignee)` Moves an artifact to a specified target folder.
    `void` | `removeArtifactDependency(String sessionId, String originId, String targetId)` Removes an artifact dependency between two artifacts.
    `void` | `reorderTrackerFields(String sessionId, String trackerId, String[] layoutIds)` Sets a new order of the fields and the separators within a tracker.
    `void` | `reorderTrackers(String sessionId, String[] trackerIds)` Sets a new order of the trackers within a project.
    `void` | `setArtifactData(String sessionId, ArtifactSoapDO artifactData, String comment, String attachmentFileName, String attachmentMimeType, String attachmentFileId)` Sets data associated with the specified artifact.
    `void` | `setArtifactData2(String sessionId, ArtifactSoapDO artifactData, String comment, AttachmentSoapDO[] attachments)` Sets data associated along with multiple attachments with the specified artifact.
    `void` | `setArtifactData3(String sessionId, Artifact2SoapDO artifactData, String comment, AttachmentSoapDO[] attachments)` Sets data associated along with multiple attachments with the specified artifact.
    `void` | `setArtifactData4(String sessionId, Artifact3SoapDO artifactData, String comment, AttachmentSoapDO[] attachments)` Sets data associated along with multiple attachments with the specified artifact.
    `void` | `setArtifactRank(String sessionId, String planningFolderId, String artfToRankId, String artfBeforeId, String artfAfterId)` Sets the rank of an artifact relative to one or more other artifacts, in the context of a specific planning folder.
    `void` | `setField(String sessionId, String objectId, TrackerFieldSoapDO fieldData)` Sets a custom/flex-field that is associated with a specific folder (e.g. tracker).
    `void` | `setField2(String sessionId, String objectId, TrackerField2SoapDO fieldData)` Sets a custom/flex-field that is associated with a specific folder (e.g. tracker).
    `void` | `setTracker2Data(String sessionId, Tracker2SoapDO trackerData)` Sets data on a specific tracker
    `void` | `setTracker3Data(String sessionId, Tracker3SoapDO trackerData)` Sets data on a specific tracker with autosum foreign children support
    `void` | `setTrackerData(String sessionId, TrackerSoapDO trackerData)` Sets data on a specific tracker, using this method and not setTracker2Data will reset the tracker unit to the default

    - ### Methods inherited from class com.collabnet.ce.soap60.webservices.ClientSoapStub

      `getServiceCall, getSoapServer, getTimeout, setTimeout`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TrackerAppSoapStub

          public TrackerAppSoapStub(String soapServerUrl)

  - ### Method Detail

    - #### getTrackerList

          public TrackerSoapList getTrackerList(String sessionId,
                                                String projectId)
                                         throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a list of trackers for a project in the order that they are displayed in the UI.
      Specified by:
        `getTrackerList` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `projectId` - Project id.
      Returns:
        List of trackers within the project.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getTracker2List

          public Tracker2SoapList getTracker2List(String sessionId,
                                                  String projectId)
                                           throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a list of trackers for a project in the order that they are displayed in the UI.
      Specified by:
        `getTracker2List` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `projectId` - Project id.
      Returns:
        List of trackers within the project.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getTracker3List

          public Tracker3SoapList getTracker3List(String sessionId,
                                                  String projectId)
                                           throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a list of trackers for a project in the order that they are displayed in the UI.
      Specified by:
        `getTracker3List` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `projectId` - Project id.
      Returns:
        List of trackers within the project.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getTrackerData

          public TrackerSoapDO getTrackerData(String sessionId,
                                              String trackerId)
                                       throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a data object for a given tracker
      Specified by:
        `getTrackerData` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Detailed data on the tracker.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getTracker2Data

          public Tracker2SoapDO getTracker2Data(String sessionId,
                                                String trackerId)
                                         throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a data object for a given tracker
      Specified by:
        `getTracker2Data` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Detailed data on the tracker.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getTracker3Data

          public Tracker3SoapDO getTracker3Data(String sessionId,
                                                String trackerId)
                                         throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a data object for a given tracker
      Specified by:
        `getTracker3Data` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Detailed data on the tracker.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### setTrackerData

          public void setTrackerData(String sessionId,
                                     TrackerSoapDO trackerData)
                              throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets data on a specific tracker, using this method and not setTracker2Data will reset the tracker unit to the default
      Specified by:
        `setTrackerData` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerData` - Detailed data on the tracker to set.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or field or icon could not be found.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when invalid data is specified.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object version mismatches the application server.
        `RemoteException`

    - #### setTracker2Data

          public void setTracker2Data(String sessionId,
                                      Tracker2SoapDO trackerData)
                               throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets data on a specific tracker
      Specified by:
        `setTracker2Data` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerData` - Detailed data on the tracker to set.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or field or icon could not be found.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when invalid data is specified.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object version mismatches the application server.
        `RemoteException`

    - #### setTracker3Data

          public void setTracker3Data(String sessionId,
                                      Tracker3SoapDO trackerData)
                               throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets data on a specific tracker with autosum foreign children support
      Specified by:
        `setTracker3Data` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerData` - Detailed data on the tracker to set.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or field or icon could not be found.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when invalid data is specified.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object version mismatches the application server.
        `RemoteException`

    - #### createTracker

          public TrackerSoapDO createTracker(String sessionId,
                                             String projectId,
                                             String trackerName,
                                             String trackerTitle,
                                             String trackerDescription,
                                             String icon)
                                      throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Creates a new tracker with an icon
      Specified by:
        `createTracker` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `projectId` - The id of the project under which to create the new tracker
        `trackerName` - The name of the new tracker
        `trackerTitle` - The title of the new tracker
        `trackerDescription` - The description of the new tracker
        `icon` - The tracker icon (null or something between "icon_01.png" and "icon_99.png")
      Returns:
        the tracker soap object
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or icon could not be found.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if an existing tracker already exists
        `RemoteException`

    - #### createTracker2

          public Tracker2SoapDO createTracker2(String sessionId,
                                               String projectId,
                                               String trackerName,
                                               String trackerTitle,
                                               String trackerDescription,
                                               String icon,
                                               String trackerUnitId)
                                        throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Creates a new tracker with an icon
      Specified by:
        `createTracker2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `projectId` - The id of the project under which to create the new tracker
        `trackerName` - The name of the new tracker
        `trackerTitle` - The title of the new tracker
        `trackerDescription` - The description of the new tracker
        `icon` - The tracker icon (null or something between "icon_01.png" and "icon_99.png")
        `trackerUnitId` - The tracker unit
      Returns:
        the tracker soap object
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or icon could not be found.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if an existing tracker already exists
        `RemoteException`

    - #### createTracker3

          public Tracker3SoapDO createTracker3(String sessionId,
                                               String projectId,
                                               String trackerName,
                                               String trackerTitle,
                                               String trackerDescription,
                                               String icon,
                                               String trackerUnitId,
                                               boolean autosumForeignChildren)
                                        throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Creates a new tracker with autosum foreign children support
      Specified by:
        `createTracker3` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `projectId` - The id of the project under which to create the new tracker
        `trackerName` - The name of the new tracker
        `trackerTitle` - The title of the new tracker
        `trackerDescription` - The description of the new tracker
        `icon` - The tracker icon (null or something between "icon_01.png" and "icon_99.png")
        `trackerUnitId` - The tracker unit
        `autosumForeignChildren` - The flag indicating whether the autosum calculation of effort and points includes children from foreign projects
      Returns:
        the tracker soap object
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or icon could not be found.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if an existing tracker already exists
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `RemoteException`

    - #### setField

          public void setField(String sessionId,
                               String objectId,
                               TrackerFieldSoapDO fieldData)
                        throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets a custom/flex-field that is associated with a specific folder (e.g. tracker). This method was introduced to be able to set properties of the help text in TeamForge 5.4.1
      Specified by:
        `setField` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `objectId` - Object (e.g. tracker) for which to set the field information.
        `fieldData` - the custom/flex-field to associate with a specific folder
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified. See FaultSummary for detail for the following: - DUPLICATE_FIELD_VALUE - ILLEGAL_FIELD_VALUE - INVALID_FIELD_VALUE - INVALID_DEFAULT_VALUE - INVALID_FIELD_OPTIONS_REQUIRED_DISABLED - INVALID_FIELD_VALUE_LENGTH - REQUIRED_FIELD_MISSING - INVALID_FIELD_PATTERN
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed. See FaultSummary for detail for the following: - INVALID_OPTION_DISABLE_RESERVED_FIELD - INVALID_OPTION_DISABLE_IN_USE_FIELD
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - if changing a status violates artifact dependency
        `RemoteException`
      See Also:
        `FaultSummary`

    - #### setField2

          public void setField2(String sessionId,
                                String objectId,
                                TrackerField2SoapDO fieldData)
                         throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets a custom/flex-field that is associated with a specific folder (e.g. tracker). This method was introduced to be able to set properties of the tracker field and also supporting to set the field role filters for the 'assignedTo' field
      Specified by:
        `setField2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `objectId` - Object (e.g. tracker) for which to set the field information.
        `fieldData` - the custom/flex-field to associate with a specific folder
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified. See FaultSummary for detail for the following: - DUPLICATE_FIELD_VALUE - ILLEGAL_FIELD_VALUE - INVALID_FIELD_VALUE - INVALID_DEFAULT_VALUE - INVALID_FIELD_OPTIONS_REQUIRED_DISABLED - INVALID_FIELD_VALUE_LENGTH - REQUIRED_FIELD_MISSING - INVALID_FIELD_PATTERN
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed. See FaultSummary for detail for the following: - INVALID_OPTION_DISABLE_RESERVED_FIELD - INVALID_OPTION_DISABLE_IN_USE_FIELD
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - if changing a status violates artifact dependency
        `RemoteException`
      See Also:
        `FaultSummary`

    - #### addTextField

          public void addTextField(String sessionId,
                                   String trackerId,
                                   String fieldName,
                                   int displayColumns,
                                   int displayLines,
                                   boolean isRequired,
                                   boolean isDisabled,
                                   boolean isHiddenOnCreate,
                                   String defaultValue,
                                   String helpText,
                                   String pattern)
                            throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Adds a custom text field to a tracker.
      Specified by:
        `addTextField` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `displayColumns` - the width of the display area
        `displayLines` - the height of the display area
        `isRequired` - if the field is required
        `isDisabled` - if the field is disabled
        `isHiddenOnCreate` - if the field is hidden when first created
        `defaultValue` - default value
        `helpText` - The help text for the field
        `pattern` - The field validation pattern
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### addSingleSelectChildField

          public void addSingleSelectChildField(String sessionId,
                                                String trackerId,
                                                String fieldName,
                                                String[] fieldValues,
                                                String parentFieldId,
                                                com.collabnet.ce.soap60.types.SoapNamedValues parentChildFieldValueMap,
                                                String helpText)
                                         throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Adds a custom single select field to a tracker.
      Specified by:
        `addSingleSelectChildField` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `fieldValues` - Array of valid field values
        `parentFieldId` - The id of the parent field
        `parentChildFieldValueMap` - soapNamedValues which keeps mapping between parent field values and child values
        `helpText` - the help text for the field
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### addSingleSelectField

          public void addSingleSelectField(String sessionId,
                                           String trackerId,
                                           String fieldName,
                                           boolean isRequired,
                                           boolean isDisabled,
                                           boolean isHiddenOnCreate,
                                           String[] fieldValues,
                                           String defaultValue,
                                           String helpText)
                                    throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Adds a custom single select field to a tracker.
      Specified by:
        `addSingleSelectField` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `isRequired` - if the field is required
        `isDisabled` - if the field is disabled
        `isHiddenOnCreate` - if the field is hidden when first created
        `fieldValues` - Array of valid field values
        `defaultValue` - default value
        `helpText` - the help text for the field
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### addMultiSelectField

          public void addMultiSelectField(String sessionId,
                                          String trackerId,
                                          String fieldName,
                                          int displayLines,
                                          boolean isRequired,
                                          boolean isDisabled,
                                          boolean isHiddenOnCreate,
                                          String[] fieldValues,
                                          String[] defaultValues,
                                          String helpText)
                                   throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Adds a custom multi select field to a tracker.
      Specified by:
        `addMultiSelectField` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `displayLines` - the height of the display area
        `isRequired` - if the field is required
        `isDisabled` - if the field is disabled
        `isHiddenOnCreate` - if the field is hidden when first created
        `fieldValues` - possible values
        `defaultValues` - default values
        `helpText` - the help text for the field
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### addUserSelectField

          public void addUserSelectField(String sessionId,
                                         String trackerId,
                                         String fieldName,
                                         int displayLines,
                                         boolean isRequired,
                                         boolean isDisabled,
                                         boolean isHiddenOnCreate,
                                         String[] defaultValues,
                                         String userFilter,
                                         String helpText)
                                  throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Adds a custom User selection field to a tracker.
      Specified by:
        `addUserSelectField` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `displayLines` - the height of the display area
        `isRequired` - if the field is required
        `isDisabled` - if the field is disabled
        `isHiddenOnCreate` - if the field is hidden when first created
        `defaultValues` - default values for this field. Must be valid usernames
        `userFilter` - is the filter
        `helpText` - The help text of the field
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      See Also:
        `TrackerFieldSoapDO.FIELD_USER_FILTER_PROJECT_MEMBER`, `TrackerFieldSoapDO.FIELD_USER_FILTER_ALL`

    - #### addDateField

          public void addDateField(String sessionId,
                                   String trackerId,
                                   String fieldName,
                                   boolean isRequired,
                                   boolean isDisabled,
                                   boolean isHiddenOnCreate,
                                   String helpText)
                            throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Adds a custom Date field to a tracker.
      Specified by:
        `addDateField` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `isRequired` - if the field is required
        `isDisabled` - if the field is disabled
        `isHiddenOnCreate` - if the field is hidden when first created
        `helpText` - the help text of the field
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### deleteField

          public void deleteField(String sessionId,
                                  String objectId,
                                  String fieldId)
                           throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Deletes a custom/flex-field .
      Specified by:
        `deleteField` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `objectId` - Object (e.g. tracker).
        `fieldId` - the id of the field to delete
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getFields

          public TrackerFieldSoapDO[] getFields(String sessionId,
                                                String trackerId)
                                         throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns the custom/flex-fields associated with a specific tracker. This method has been introduced to also return the properties of the planning folder, the actual, estimated and remaining effort fields as well as the autosumming flag.
      Specified by:
        `getFields` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker for which to return field information.
      Returns:
        Array of all field values.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getFields2

          public TrackerField2SoapDO[] getFields2(String sessionId,
                                                  String trackerId)
                                           throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns the custom/flex-fields associated with a specific tracker. In addition to the features of getFields api, it returns the field role filters of the field(eg: 'assignedTo' field) in the Tracker
      Specified by:
        `getFields2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker for which to return field information.
      Returns:
        Array of all field values.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### addSeparator

          public void addSeparator(String sessionId,
                                   String trackerId,
                                   String separatorType,
                                   String separatorLabel)
                            throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Adds a separator to a tracker. The separator will be added at the end of tracker fields. To reorder separator and fields, use getOrderedTrackerFields and reorderTrackerFields.
      Specified by:
        `addSeparator` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the separator to.
        `separatorType` - the type of the separator, either OrderedTrackerFieldSoapRow.ROW_SEPARATOR OrderedTrackerFieldSoapRow.COLUMN_SEPARATOR or OrderedTrackerFieldSoapRow .SECTION_SEPARATOR.
        `separatorLabel` - the label of the separator
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if a separator with the same id exists
        `RemoteException`

    - #### deleteSeparator

          public void deleteSeparator(String sessionId,
                                      String trackerId,
                                      String layoutId)
                               throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Deletes a separator of a tracker layout.
      Specified by:
        `deleteSeparator` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to delete the separator from.
        `layoutId` - the layout id of the separator. To get the layout id, use getOrderedTrackerFields.
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getOrderedTrackerFields

          public OrderedTrackerFieldSoapList getOrderedTrackerFields(String sessionId,
                                                                     String trackerId)
                                                              throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns all fields and separators in the given tracker with layout information.
      Specified by:
        `getOrderedTrackerFields` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker for which to return field information.
      Returns:
        Array of all fields and separators.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### reorderTrackerFields

          public void reorderTrackerFields(String sessionId,
                                           String trackerId,
                                           String[] layoutIds)
                                    throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets a new order of the fields and the separators within a tracker. The fields and separators will be listed in this new order in UI and in the methods that list the fields and separators in the SOAP calls.
      Specified by:
        `reorderTrackerFields` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Id of tracker which all the fields and the separators belong to.
        `layoutIds` - An array of layout ids which can be obtained by getOrderedTrackerFields(). Layout id is different from field id and some system fields and separators do not have field id but only layout id.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - When the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - When any of the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - If invalid argument value is passed.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - When the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - When an unexpected system level error occurs.
        `RemoteException`

    - #### getArtifactList

          public ArtifactSoapList getArtifactList(String sessionId,
                                                  String containerId,
                                                  com.collabnet.ce.soap60.types.SoapFilter[] filters)
                                           throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a filtered list of artifacts within the specified container (project or tracker). See ArtifactSoapDO for filter constant values: ArtifactSoapDO.FILTER_ASSIGNED_TO, etc.
      Change History
      Version 4.2
      - Added additional parameter (`filters`) for filtering artifact lists.
      Version 4.4
      - Added a limit to the number of rows that could be retrieved. This limit is by default 5000 but is configurable
      - it is substantially obsolete by enhancements to getArtifactDetailList(), which now includes the ability to select which columns are returned, as well as the ability to fetch subsets of data on a "paged" basis, and to return sorted results.
      Specified by:
        `getArtifactList` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `containerId` - ID of a project or a tracker.
        `filters` - Array of filters to apply (null to return unfiltered list).
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getArtifactList2

          public Artifact2SoapList getArtifactList2(String sessionId,
                                                    String containerId,
                                                    com.collabnet.ce.soap60.types.SoapFilter[] filters)
                                             throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a filtered list of artifacts within the specified container (project or tracker). See ArtifactSoapDO for filter constant values: ArtifactSoapDO.FILTER_ASSIGNED_TO, etc.
      Specified by:
        `getArtifactList2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `containerId` - ID of a project or a tracker.
        `filters` - Array of filters to apply (null to return unfiltered list).
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getCrossTrackerArtifactList

          public ArtifactDetailSoapList getCrossTrackerArtifactList(String sessionId,
                                                                    String containerId,
                                                                    com.collabnet.ce.soap60.types.SoapFilter[] filters,
                                                                    String[] selectedColumns)
                                                             throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a filtered list of artifacts within the specified container (project or tracker). Since this is a cross tracker query, flex fields may not be populated.
      Specified by:
        `getCrossTrackerArtifactList` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `containerId` - ID of a project or a tracker. (should not be null)
        `filters` - Array of filters to apply (null to return unfiltered list).
        `selectedColumns` - String array of column names to be selected (null to return all columns). See ArtifactSoapDO for column names constant values e.g. ArtifactSoapDO.COLUMN_CATEGORY
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getCrossTrackerArtifactList2

          public ArtifactDetail2SoapList getCrossTrackerArtifactList2(String sessionId,
                                                                      String containerId,
                                                                      com.collabnet.ce.soap60.types.SoapFilter[] filters,
                                                                      String[] selectedColumns)
                                                               throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a filtered list of artifacts within the specified container (project or tracker). Since this is a cross tracker query, flex fields may not be populated.
      Specified by:
        `getCrossTrackerArtifactList2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `containerId` - ID of a project or a tracker. (should not be null)
        `filters` - Array of filters to apply (null to return unfiltered list).
        `selectedColumns` - String array of column names to be selected (null to return all columns). See Artifact2SoapDO for column names constant values e.g. Artifact2SoapDO.COLUMN_CATEGORY.
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getArtifactDetailList

          public ArtifactDetailSoapList getArtifactDetailList(String sessionId,
                                                              String trackerId,
                                                              String[] selectedColumns,
                                                              com.collabnet.ce.soap60.types.SoapFilter[] filters,
                                                              com.collabnet.ce.soap60.types.SoapSortKey[] sortKeys,
                                                              int startIndex,
                                                              int maxRows,
                                                              boolean exceptionIfExpiredCache,
                                                              boolean forceNewQuery)
                                                       throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a filtered and ordered list of artifacts from the specified tracker. It gives the user the ability to ask only for certain results with the parameters startIndex and maxRows. In this way the method can be used to implement paging. A special value of -1 for the maxRows parameter will be interpreted as asking for the complete list. Unlike the corresponding method in earlier versions of the soap interface (soap44, etc.), this method now returns data for all flex fields, whether they have values or not. Flex fields with no values will have NULL values in the values[] array

      This method makes use of server-side caching of the complete list in order to more efficiently return results for requests for subsequent "pages" of data. In normal usage, requesting a subsequent page of a given list will return data from this cache unless the cache has expired, in which case the query will transparently be re-executed before return the results. Note that this transparent re-execution can result in slight inconsistencies in the data, if the underlying data has changed. The exceptionIfExpiredCache and forceNewQuery flags can be used to tune cache behavior.

      Caching is managed transparently by the application server, using the filters and selectedColumns parameters to identify subsequent requests for subsets of the same data set. The cache is associated with the user session. Note that the implementation may choose not to cache results if the entire list is being fetched (via specifying -1 for maxRows).

      Note: You can't sort or filter by a non selected column.

      See ArtifactSoapDO for column and filter names constant values: ArtifactSoapDO.COLUMN_TITLE, ArtifactSoapDO.COLUMN_ASSIGNED_TO, FILTER_PRIORITY, FILTER, FILTER_CATEGORY, etc.

      Specified by:
        `getArtifactDetailList` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
        `selectedColumns` - String array of column names to be selected (null to return all columns). See ArtifactSoapDO for column names constant values e.g. ArtifactSoapDO .COLUMN_CATEGORY
        `filters` - Array of filters to apply (null to return unfiltered list). See ArtifactSoapDO for filters names constant values e.g. ArtifactSoapDO .FILTER_PRIORITY. Valid date formats are SoapFilter.DATE_FORMAT and SoapFilter.DATE_ONLY_FORMAT.
        `sortKeys` - Array of `SortKey` to apply (null to return a default order list that is by ID). See ArtifactSoapDO for column names constant values e.g. ArtifactSoapDO .COLUMN_PRIORITY
        `startIndex` - The index from which to return the results.
        `maxRows` - The max quantity of elements to be returned (-1 will return the full list).
        `exceptionIfExpiredCache` - Causes the method to throw an exception if it doesn't have the results in the cache, rather than the default behavior of silently re-executing the query. This can be used if the caller is fetching paged data and wants to be assured that the pages are from one consistent snapshot of the data.
        `forceNewQuery` - force the re-execution of the query, ignoring any cached copy of the search result.
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getArtifactDetailList2

          public ArtifactDetail2SoapList getArtifactDetailList2(String sessionId,
                                                                String trackerId,
                                                                String[] selectedColumns,
                                                                com.collabnet.ce.soap60.types.SoapFilter[] filters,
                                                                com.collabnet.ce.soap60.types.SoapSortKey[] sortKeys,
                                                                int startIndex,
                                                                int maxRows,
                                                                boolean exceptionIfExpiredCache,
                                                                boolean forceNewQuery)
                                                         throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns a filtered and ordered list of artifacts from the specified tracker. It gives the user the ability to ask only for certain results with the parameters startIndex and maxRows. In this way the method can be used to implement paging. A special value of -1 for the maxRows parameter will be interpreted as asking for the complete list. Unlike the corresponding method in earlier versions of the soap interface (soap44, etc.), this method now returns data for all flex fields, whether they have values or not. Flex fields with no values will have NULL values in the values[] array

      This method makes use of server-side caching of the complete list in order to more efficiently return results for requests for subsequent "pages" of data. In normal usage, requesting a subsequent page of a given list will return data from this cache unless the cache has expired, in which case the query will transparently be re-executed before return the results. Note that this transparent re-execution can result in slight inconsistencies in the data, if the underlying data has changed. The exceptionIfExpiredCache and forceNewQuery flags can be used to tune cache behavior.

      Caching is managed transparently by the application server, using the filters and selectedColumns parameters to identify subsequent requests for subsets of the same data set. The cache is associated with the user session. Note that the implementation may choose not to cache results if the entire list is being fetched (via specifying -1 for maxRows).

      Note: You can't sort or filter by a non selected column.

      See ArtifactSoapDO for column and filter names constant values: ArtifactSoapDO.COLUM ArtifactSoapDO.COLUMN_ASSIGNED_TO, FILTER_PRIORITY, FILTER, FILTER_CATEGORY, etc.

      Specified by:
        `getArtifactDetailList2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.

        See ArtifactSoapDO for filters names constant values e.g. ArtifactSoapDO .FILTER_PRIORITY. Valid date formats are SoapFilter.DATE_FORMAT and SoapFilter.DATE_ONLY_FORMAT.

        `sortKeys` - Array of `SortKey` to apply (null to return a default order list that is by ID). See ArtifactSoapDO for column names constant values e.g. Artifact2SoapDO .COLUMN_AUTO_SUMMING_POINTS
        `startIndex` - The index from which to return the results.
        `maxRows` - The max quantity of elements to be returned (-1 will return the full list).
        `exceptionIfExpiredCache` - Causes the method to throw an exception if it doesn't have the results in the cache, rather than the default behavior of silently re-executing the query. This can be used if the caller is fetching paged data and wants to be assured that the pages are from one consistent snapshot of the data.
        `forceNewQuery` - force the re-execution of the query, ignoring any cached copy of the search result.
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### findArtifacts

          public ArtifactSoapList findArtifacts(String sessionId,
                                                String queryString,
                                                String projectId,
                                                boolean searchAttachments)
                                         throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Finds a list of artifacts matching a search string.
      Specified by:
        `findArtifacts` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `queryString` - Query string.
        `projectId` - The project in which to find artifacts. (if null, search all projects)
        `searchAttachments` - Whether to search attachments.
      Returns:
        List of artifacts matching search criteria.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified project id is invalid.
        `com.collabnet.ce.soap60.fault.SearchQuerySyntaxFault` - when the specified search query string is syntactically invalid.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the specified query string is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`

    - #### findArtifacts2

          public Artifact2SoapList findArtifacts2(String sessionId,
                                                  String queryString,
                                                  String projectId,
                                                  boolean searchAttachments)
                                           throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Finds a list of artifacts matching a search string.
      Specified by:
        `findArtifacts2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `queryString` - Query string.
        `projectId` - The project in which to find artifacts. (if null, search all projects)
        `searchAttachments` - Whether to search attachments.
      Returns:
        List of artifacts matching search criteria.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified project id is invalid.
        `com.collabnet.ce.soap60.fault.SearchQuerySyntaxFault` - when the specified search query string is syntactically invalid.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the specified query string is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`

    - #### getArtifactData

          public ArtifactSoapDO getArtifactData(String sessionId,
                                                String artifactId)
                                         throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns data associated with the specified artifact. Unlike the corresponding method in earlier versions of the soap interface (soap44, etc.), this method now returns data for all flex fields, whether they have values or not. Flex fields with no values will have NULL values in the values[] array
      Specified by:
        `getArtifactData` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Returns:
        the data associated with the artifact at the given path
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getArtifactData2

          public Artifact2SoapDO getArtifactData2(String sessionId,
                                                  String artifactId)
                                           throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns data associated with the specified artifact. Unlike the corresponding method in earlier versions of the soap interface (soap44, etc.), this method now returns data for all flex fields, whether they have values or not. Flex fields with no values will have NULL values in the values[] array
      Specified by:
        `getArtifactData2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Returns:
        the data associated with the artifact at the given path
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### getArtifactData3

          public Artifact3SoapDO getArtifactData3(String sessionId,
                                                  String artifactId)
                                           throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Returns data associated with the specified artifact. Unlike the corresponding method in earlier versions of the soap interface (soap44, etc.), this method now returns data for all flex fields, whether they have values or not. Flex fields with no values will have NULL values in the values[] array
      Specified by:
        `getArtifactData3` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Returns:
        the data associated with the artifact at the given path
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### setArtifactData

          public void setArtifactData(String sessionId,
                                      ArtifactSoapDO artifactData,
                                      String comment,
                                      String attachmentFileName,
                                      String attachmentMimeType,
                                      String attachmentFileId)
                               throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets data associated with the specified artifact.
      Specified by:
        `setArtifactData` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactData` - the data associated with the artifact at the given path
        `comment` - Comment associated with the change.
        `attachmentFileName` - Name of the attached file (or null)
        `attachmentMimeType` - Mime type of the attached file (or null)
        `attachmentFileId` - ID of the attached file (previously uploaded via *FileStorage service) or null
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object data is stale.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when workflow rule is violated
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when dependency rule is violated
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `RemoteException`

    - #### setArtifactData2

          public void setArtifactData2(String sessionId,
                                       ArtifactSoapDO artifactData,
                                       String comment,
                                       AttachmentSoapDO[] attachments)
                                throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets data associated along with multiple attachments with the specified artifact.
      Specified by:
        `setArtifactData2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactData` - the data associated with the artifact at the given path
        `comment` - Comment associated with the change.
        `attachments` - attached file List
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object data is stale.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when workflow rule is violated
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when dependency rule is violated
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `RemoteException`

    - #### setArtifactData3

          public void setArtifactData3(String sessionId,
                                       Artifact2SoapDO artifactData,
                                       String comment,
                                       AttachmentSoapDO[] attachments)
                                throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets data associated along with multiple attachments with the specified artifact.
      Specified by:
        `setArtifactData3` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactData` - the data associated with the artifact at the given path
        `comment` - Comment associated with the change.
        `attachments` - attached file List
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object data is stale.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when workflow rule is violated
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when dependency rule is violated
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `RemoteException`

    - #### setArtifactData4

          public void setArtifactData4(String sessionId,
                                       Artifact3SoapDO artifactData,
                                       String comment,
                                       AttachmentSoapDO[] attachments)
                                throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets data associated along with multiple attachments with the specified artifact.
      Specified by:
        `setArtifactData4` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactData` - the data associated with the artifact at the given path
        `comment` - Comment associated with the change.
        `attachments` - attached file List
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object data is stale.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when workflow rule is violated
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when dependency rule is violated
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
        `RemoteException`

    - #### createArtifact

          public ArtifactSoapDO createArtifact(String sessionId,
                                               String trackerId,
                                               String title,
                                               String description,
                                               String group,
                                               String category,
                                               String status,
                                               String customer,
                                               int priority,
                                               int estimatedEffort,
                                               int remainingEffort,
                                               boolean autosumming,
                                               int points,
                                               String assignedUsername,
                                               String releaseId,
                                               String planningFolderId,
                                               com.collabnet.ce.soap60.types.SoapFieldValues flexFields,
                                               String attachmentFileName,
                                               String attachmentMimeType,
                                               String attachmentFileId)
                                        throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Creates a new artifact.
      Specified by:
        `createArtifact` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
        `title` - Artifact title.
        `description` - Artifact description.
        `group` - Artifact group.
        `category` - Artifact category.
        `status` - Artifact status.
        `customer` - Customer.
        `priority` - Artifact priority.
        `estimatedEffort` - Estimated effort to close artifact.
        `remainingEffort` - Remaining effort to close artifact.
        `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
        `points` - The story points for this artifact.
        `assignedUsername` - User this artifact should be assigned to.
        `releaseId` - Release this artifact is assigned with.
        `planningFolderId` - planning folder, this artifact belongs to
        `flexFields` - Flex field values.
        `attachmentFileName` - Name of the attached file (or null)
        `attachmentMimeType` - Mime type of the attached file (or null)
        `attachmentFileId` - ID of the attached file (previously uploaded via *FileStorage service) or null
      Returns:
        Newly created artifact object.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### createArtifact2

          public ArtifactSoapDO createArtifact2(String sessionId,
                                                String trackerId,
                                                String title,
                                                String description,
                                                String group,
                                                String category,
                                                String status,
                                                String customer,
                                                int priority,
                                                int estimatedEffort,
                                                int remainingEffort,
                                                boolean autosumming,
                                                int points,
                                                String assignedUsername,
                                                String releaseId,
                                                String planningFolderId,
                                                com.collabnet.ce.soap60.types.SoapFieldValues flexFields,
                                                AttachmentSoapDO[] attachments)
                                         throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Creates a new artifact with multiple attachments.
      Specified by:
        `createArtifact2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
        `title` - Artifact title.
        `description` - Artifact description.
        `group` - Artifact group.
        `category` - Artifact category.
        `status` - Artifact status.
        `customer` - Customer.
        `priority` - Artifact priority.
        `estimatedEffort` - Estimated effort to close artifact.
        `remainingEffort` - Remaining effort to close artifact.
        `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
        `points` - The story points for this artifact.
        `assignedUsername` - User this artifact should be assigned to.
        `releaseId` - Release this artifact is assigned with.
        `planningFolderId` - planning folder, this artifact belongs to
        `flexFields` - Flex field values.
        `attachments` - attached file List (or null)
      Returns:
        Newly created artifact object.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### createArtifact3

          public Artifact2SoapDO createArtifact3(String sessionId,
                                                 String trackerId,
                                                 String title,
                                                 String description,
                                                 String group,
                                                 String category,
                                                 String status,
                                                 String customer,
                                                 int priority,
                                                 int estimatedEffort,
                                                 int remainingEffort,
                                                 boolean autosumming,
                                                 int points,
                                                 boolean autoSummingPoints,
                                                 String assignedUsername,
                                                 String releaseId,
                                                 String planningFolderId,
                                                 String teamId,
                                                 com.collabnet.ce.soap60.types.SoapFieldValues flexFields,
                                                 AttachmentSoapDO[] attachments)
                                          throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Creates a new artifact with multiple attachments and flag to enable the autosumming_points.
      Specified by:
        `createArtifact3` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
        `title` - Artifact title.
        `description` - Artifact description.
        `group` - Artifact group.
        `category` - Artifact category.
        `status` - Artifact status.
        `customer` - Customer.
        `priority` - Artifact priority.
        `estimatedEffort` - Estimated effort to close artifact. This will be ignored if autosumming is set to true.
        `remainingEffort` - Remaining effort to close artifact. This will be ignored if autosumming is set to true.
        `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
        `points` - The story points for this artifact. This will be ignored if autoSummingPoints is set to true.
        `autoSummingPoints` - Determines whether autoSummingPoints should be enabled for the newly created artifact.
        `assignedUsername` - User this artifact should be assigned to.
        `releaseId` - Release this artifact is assigned with.
        `planningFolderId` - planning folder, this artifact belongs to
        `teamId` - team, this artifact belongs to
        `flexFields` - Flex field values.
        `attachments` - attached file List (or null)
      Returns:
        Newly created artifact object.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`

    - #### createArtifact4

          public Artifact3SoapDO createArtifact4(String sessionId,
                                                 String trackerId,
                                                 String title,
                                                 String description,
                                                 String group,
                                                 String category,
                                                 String status,
                                                 String customer,
                                                 int priority,
                                                 int estimatedEffort,
                                                 int remainingEffort,
                                                 boolean autosumming,
                                                 int points,
                                                 boolean autoSummingPoints,
                                                 String assignedUsername,
                                                 String releaseId,
                                                 String planningFolderId,
                                                 String teamId,
                                                 com.collabnet.ce.soap60.types.SoapFieldValues flexFields,
                                                 AttachmentSoapDO[] attachments,
                                                 String[] tagNames)
                                          throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Creates a new artifact with multiple attachments, flag to enable the autosumming_points and tags.
      Specified by:
        `createArtifact4` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
        `title` - Artifact title.
        `description` - Artifact description.
        `group` - Artifact group.
        `category` - Artifact category.
        `status` - Artifact status.
        `customer` - Customer.
        `priority` - Artifact priority.
        `estimatedEffort` - Estimated effort to close artifact. This will be ignored if autosumming is set to true.
        `remainingEffort` - Remaining effort to close artifact. This will be ignored if autosumming is set to true.
        `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
        `points` - The story points for this artifact. This will be ignored if autoSummingPoints is set to true.
        `autoSummingPoints` - Determines whether autoSummingPoints should be enabled for the newly created artifact.
        `assignedUsername` - User this artifact should be assigned to.
        `releaseId` - Release this artifact is assigned with.
        `planningFolderId` - planning folder, this artifact belongs to
        `teamId` - team, this artifact belongs to
        `flexFields` - Flex field values.
        `attachments` - attached file List (or null)
        `tagNames` - tag names
        Note:. Tags will be created, if they do not exist in the project.
        Use TagAppSoap#listTags(java.lang.String, java.lang.String) to get the tags existing in a project.
      Returns:
        Newly created artifact object.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
        `RemoteException`

    - #### moveArtifact

          public ArtifactSoapDO moveArtifact(String sessionId,
                                             String artifactId,
                                             String targetFolderId,
                                             String newAssignee)
                                      throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Moves an artifact to a specified target folder.
      Specified by:
        `moveArtifact` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactId` - ID of artifact to move.
        `targetFolderId` - Target folder ID.
        `newAssignee` - The username to assign the newly moved artifact to.
      Returns:
        New artifact data object
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the sessionId is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when permission is denied for the specified operation.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when an invalid argument is passed in.
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `RemoteException`

    - #### moveArtifact2

          public Artifact2SoapDO moveArtifact2(String sessionId,
                                               String artifactId,
                                               String targetFolderId,
                                               String newAssignee)
                                        throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Moves an artifact to a specified target folder.
      Specified by:
        `moveArtifact2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactId` - ID of artifact to move.
        `targetFolderId` - Target folder ID.
        `newAssignee` - The username to assign the newly moved artifact to.
      Returns:
        New artifact data object
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the sessionId is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when permission is denied for the specified operation.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when an invalid argument is passed in.
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `RemoteException`

    - #### deleteArtifact

          public void deleteArtifact(String sessionId,
                                     String artifactId)
                              throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Deletes an artifact.
      Specified by:
        `deleteArtifact` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`

    - #### getAllowedWorkflowTransitionList

          public WorkflowTransitionSoapList getAllowedWorkflowTransitionList(String sessionId,
                                                                             String trackerId)
                                                                      throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Gets workflow transitions for the tracker.
      Change History
      Version 4.4 SP 1
      - Added the missing [new artifact] transitions to the list
      - The returning list now will contain [new artifact] transition list with the following format [from value] [to value] null open null close null pending
      Specified by:
        `getAllowedWorkflowTransitionList` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Workflow definitions list. For requiredFields property of workflow definition, following special field IDs are used (in addition to standard field definitions in ArtifactSoapDO): "comment", "attachment", "assignedTo", "priority".
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when ...
        `RemoteException`

    - #### getAllowedWorkflowTransitionList2

          public WorkflowTransition2SoapList getAllowedWorkflowTransitionList2(String sessionId,
                                                                               String trackerId)
                                                                        throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Gets workflow transitions for the tracker.
      Change History
      Version 17.8
      - Added 'hiddenFields' info to transition data
      Version 4.4 SP 1
      - Added the missing [new artifact] transitions to the list
      - The returning list now will contain [new artifact] transition list with the following format [from value] [to value] null open null close null pending
      Specified by:
        `getAllowedWorkflowTransitionList2` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Workflow definitions list. For requiredFields and hiddenFields properties of workflow definition, following special field IDs are used (in addition to standard field definitions in ArtifactSoapDO): "comment", "attachment", "assignedTo", "priority".
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when ...
        `RemoteException`

    - #### copyWorkflowTransitions

          public void copyWorkflowTransitions(String sessionId,
                                              String srcTrackerId,
                                              String dstTrackerId)
                                       throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Copies workflow transitions between two trackers.

      In order for this operation to succeed, the following conditions must be met: - caller needs to have tracker admin permission for both srTracker and destTracker - every transition req role in srcTracker must have corresponding role with the same name in dstTracker - every transition req field in srcTracker must have corresponding field with the same name in dstTracker or be a custom field name.

      Specified by:
        `copyWorkflowTransitions` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `srcTrackerId` - Tracker id.
        `dstTrackerId` - Tracker id.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when the copy of workflow transition cannot be completed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`

    - #### cloneTracker

          public Tracker2SoapDO cloneTracker(String sessionId,
                                             String srcTrackerId,
                                             String destTrackerTitle,
                                             String destTrackerDescription)
                                      throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Clone Tracker within the same project
      Specified by:
        `cloneTracker` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `srcTrackerId` - Tracker id.
        `destTrackerTitle` - destination Tracker tile
        `destTrackerDescription` - destination Tracker description
      Returns:
        returns cloned Tracker
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if an existing tracker already exists.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`

    - #### cloneTrackerAcrossProject

          public Tracker2SoapDO cloneTrackerAcrossProject(String sessionId,
                                                          String srcTrackerId,
                                                          String destProjectId,
                                                          String destTrackerTitle,
                                                          String destTrackerDescription)
                                                   throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Clone Tracker across the project
      Specified by:
        `cloneTrackerAcrossProject` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `srcTrackerId` - Tracker id.
        `destProjectId` - on which project you need to create a tracker
        `destTrackerTitle` - destination tracker title
        `destTrackerDescription` - destination tracker description
      Returns:
        returns cloned tracker
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if an existing tracker already exists.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`

    - #### createArtifactDependency

          public void createArtifactDependency(String sessionId,
                                               String originId,
                                               String targetId,
                                               String desc)
                                        throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Creates an artifact dependency between two artifacts. If an existing artifact dependency already exists, the descriptions are simply overridden.
      Specified by:
        `createArtifactDependency` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `originId` - Origin artifact id.
        `targetId` - Target artifact id.
        `desc` - Description for the dependency.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when the copy of workflow transition cannot be completed
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when the creation of the dependency causes violation
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`

    - #### removeArtifactDependency

          public void removeArtifactDependency(String sessionId,
                                               String originId,
                                               String targetId)
                                        throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Removes an artifact dependency between two artifacts.
      Specified by:
        `removeArtifactDependency` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `originId` - Origin artifact id.
        `targetId` - Target artifact id.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when the copy of workflow transition cannot be completed
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when the creation of the dependency causes violation
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `com.collabnet.ce.soap60.fault.NoSuchRelationshipFault` - when ...
        `RemoteException`

    - #### setArtifactRank

          public void setArtifactRank(String sessionId,
                                      String planningFolderId,
                                      String artfToRankId,
                                      String artfBeforeId,
                                      String artfAfterId)
                               throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets the rank of an artifact relative to one or more other artifacts, in the context of a specific planning folder.

      If two artifacts are specified for artfBeforeId and artfAfterId, then the moved artifact is placed between them. If only artfBeforeId is specified, the moved artifact is placed after it; if only artfAfterId, the moved artifact is moved before it.

      The ranking will be invalid if it doesn't respect certain rules:

      - artifacts cannot be ranked relative to other artifacts unless at least one of the following is true:

      1. they are children of the same parent
      2. they appear at the top level in the planning folder view, i.e. do not have a parent in the specified planning folder.

      - all specified artifacts must belong to the same project as the specified planning folder.

      As of TeamForge 5.4, this operation requires the Planning Folder Admin permission; edit permission on the trackers involved is not sufficient. In the future, a distinct role permission for rank operations may be defined.

      Specified by:
        `setArtifactRank` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `planningFolderId` - the id of the planning folder in which we are doing the rank
        `artfToRankId` - the artifact to rank
        `artfBeforeId` - the artifact that should be before it
        `artfAfterId` - the artifact that should be after it
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when one of the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the specified id is invalid.
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `com.collabnet.ce.soap60.fault.InvalidRankFault` - when the requested rank operation is invalid
        `RemoteException`

    - #### getChildDependencyList

          public ArtifactDependencySoapList getChildDependencyList(String sessionId,
                                                                   String artifactId)
                                                            throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Gets the dependency list for an artifact where the artifact is the origin artifact.
      Specified by:
        `getChildDependencyList` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Returns:
        dependency list
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when the copy of workflow transition cannot be completed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`

    - #### getParentDependencyList

          public ArtifactDependencySoapList getParentDependencyList(String sessionId,
                                                                    String artifactId)
                                                             throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Gets the dependency list for an artifact where the artifact is the target artifact. While in 5.3, an artifact can only have a single parent, that can be changed in future releases.
      Specified by:
        `getParentDependencyList` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Returns:
        dependency list
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when the copy of workflow transition cannot be completed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`

    - #### reorderTrackers

          public void reorderTrackers(String sessionId,
                                      String[] trackerIds)
                               throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Sets a new order of the trackers within a project. The trackers will be listed in this new order in UI and in the methods that list the trackers in the SOAP calls.
      Specified by:
        `reorderTrackers` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerIds` - An array of the tracker ids in their new order. All the tracker ids must belong to the same project
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - When the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - When any of the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - When the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - When an unexpected system level error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - If invalid argument value is passed.
        `RemoteException`

    - #### getUnitsByProject

          public TrackerUnitSoapList getUnitsByProject(String sessionId,
                                                       String projectId)
                                                throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Gets the units for a given project.
      Specified by:
        `getUnitsByProject` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `projectId` - The id of the project to retrieve the units
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - When the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - When any of the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - When the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - When an unexpected system level error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - If invalid argument value is passed.
        `RemoteException`

    - #### getAllowedWorkflowTransitionList3

          public WorkflowTransition3SoapList getAllowedWorkflowTransitionList3(String sessionId,
                                                                               String trackerId)
                                                                        throws RemoteException

      Description copied from interface: `ITrackerAppSoap`
      Gets workflow transitions for the tracker.
      Change History
      Version 17.11
      - Added 'autoPopulateData' info to transition data
      Version 4.4 SP 1
      - Added the missing [new artifact] transitions to the list
      - The returning list now will contain [new artifact] transition list with the following format [from value] [to value] null open null close null pending
      Specified by:
        `getAllowedWorkflowTransitionList3` in interface `ITrackerAppSoap`
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Workflow definitions list. For requiredFields, hiddenFields and autoPopulateData properties of workflow definition, following special field IDs are used (in addition to standard field definitions in ArtifactSoapDO): "comment", "attachment", "assignedTo", "priority".
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when ...
        `RemoteException`

Copyright © 2020 CollabNet. All rights reserved.